import greenfoot.*;
import java.util.List;

public class MouseControl extends Actor
{
    static String block;
    int slightDelay = 1;
    int x = 0;
    int y = 0;
    boolean inRange = false;
    int timer=0;
    
    public void changeBlock(String newBlock)
    {
        block=newBlock;
    }
    
    public void act() 
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        //This makes sure the mouse is in range of the player
        List player = getObjectsInRange(100, Player.class);
        if (! player.isEmpty()){    
            Actor Player = (Actor) player.get(0);
            if (Player!=null){
                x = Player.getX();
                y = Player.getY();
                if (x-getX()<100&&x-getX()>-100&&y-getY()<100&&y-getY()>-100){
                    inRange=true;
                }else{
                    inRange=false;
                }
            }
        }
        //Code for the mouse's functions
        if (mouse!=null/*&&inRange==true*/){
            setLocation(mouse.getX(),mouse.getY());
            int button=mouse.getButton();
            if (slightDelay==0){
                if (button==1){
                    slightDelay=1;
                    //All possible Objects that will be removed when clicked on
                    Actor a = getOneObjectAtOffset(0,0,Grass.class);
                    Actor b = getOneObjectAtOffset(0,0,Dirt.class);
                    Actor c = getOneObjectAtOffset(0,0,Stone.class);
                    Actor d = getOneObjectAtOffset(0,0,Ladder.class);
                    Actor e = getOneObjectAtOffset(0,0,LiquoriceLog.class);
                    Actor f = getOneObjectAtOffset(0,0,LightLeaves.class);
                    //Check for if any of the possible objects is clicked, and if so, remove them
                    if (a!=null){
                        getWorld().removeObject(a);
                    }else if (b!=null){
                        getWorld().removeObject(b);
                    }else if (c!=null){
                        getWorld().removeObject(c);
                    }else if (d!=null){
                        getWorld().removeObject(d);
                    }else if (e!=null){
                        getWorld().removeObject(e);
                    }else if (f!=null){
                        getWorld().removeObject(f);
                    }
                }
                if (button==3){
                    if (block.equals("Ladder")){
                        if (getOneObjectAtOffset(0,0,Grass.class)!=null||getOneObjectAtOffset(0,0,Dirt.class)!=null||getOneObjectAtOffset(0,0,Stone.class)!=null||getOneObjectAtOffset(0,0,Ladder.class)!=null||getOneObjectAtOffset(0,0,LiquoriceLog.class)!=null||getOneObjectAtOffset(0,0,LightLeaves.class)!=null){}else{
                            getWorld().addObject(new Ladder(),getX(),getY());
                        }
                    }
                    if (block.equals("Bomb")){
                        if (timer==0){
                            getWorld().addObject(new Bomb(),getX(),getY());
                            timer=1;
                        }else{
                            timer--;
                        }
                    }
                }
            }else{
                slightDelay=0;
            }
        }   
    }
}
