//19 pixels tall and 18 pixels wide

import greenfoot.*;
import java.util.List;

public class Bomb extends Actor
{
    int fuse=100;
    public void act() 
    {
        explosionPhysics();
        physics();
        //Fuse
        if (fuse==0){
            getWorld().addObject(new Explosion(),getX(),getY());
            getWorld().removeObject(this);
        }else{
            fuse--;
        }
    }
    int xmove=0;
    int ymove=0;
    int ymoveAmount=1;
    int jump=0;
    int fall=1;
    int fallonce=1;
    int falltimer=0;
    int jumplimit=0;
    int rightlimit=0;
    int leftblock=0;
    int speed=2;
    boolean activate=false;
    boolean thrown=false;
    public void explosionPhysics()
    {
        Actor boom = getOneIntersectingObject(Explosion.class);
        if (boom!=null){
            thrown=true;
            if (activate==false)activate=true; fuse=5;
            if (boom.getX()>getX())xmove=-13;
            if (boom.getX()<getX())xmove=13;
            if (boom.getY()>getY())ymove=-13;
            if (boom.getY()<getY())ymove=13;
        }
    }
    int co=getImage().getWidth()/2;
    public void physics() 
    {
        if (thrown==true){
            if (xmove<0){
                xmove+=1;
            }
            if (xmove>0){
                xmove-=1;
            }
            if (ymove<0){
                ymove+=1;
            }
            if (xmove==0&&ymove==0){
                thrown=false;
            }
        }
        //Down Collision
        Actor downco = getOneObjectAtOffset( 0, co, Grass.class);
        Actor downco2 = getOneObjectAtOffset( -co, co, Grass.class);
        Actor downco3 = getOneObjectAtOffset( co, co, Grass.class);
        Actor downco4 = getOneObjectAtOffset( 0, co, Dirt.class);
        Actor downco5 = getOneObjectAtOffset( -co, co, Dirt.class);
        Actor downco6 = getOneObjectAtOffset( co, co, Dirt.class);
        Actor downco7 = getOneObjectAtOffset( 0, co, Stone.class);
        Actor downco8 = getOneObjectAtOffset( -co, co, Stone.class);
        Actor downco9 = getOneObjectAtOffset( co, co, Stone.class);
        Actor downco10 = getOneObjectAtOffset( 0, co, LiquoriceLog.class);
        Actor downco11 = getOneObjectAtOffset( -co, co, LiquoriceLog.class);
        Actor downco12 = getOneObjectAtOffset( co, co, LiquoriceLog.class);
        Actor downco13 = getOneObjectAtOffset( 0, co, LightLeaves.class);
        Actor downco14 = getOneObjectAtOffset( -co, co, LightLeaves.class);
        Actor downco15 = getOneObjectAtOffset( co, co, LightLeaves.class);
        Actor downco16 = getOneObjectAtOffset( 0, co, CopperOre.class);
        Actor downco17 = getOneObjectAtOffset( -co, co, CopperOre.class);
        Actor downco18 = getOneObjectAtOffset( co, co, CopperOre.class);
        //Up Collision
        Actor upco = getOneObjectAtOffset( 0, -co, Grass.class);
        Actor upco2 = getOneObjectAtOffset( 0, -co, Dirt.class);
        Actor upco3 = getOneObjectAtOffset( 0, -co, Stone.class);
        Actor upco4 = getOneObjectAtOffset( 0, -co, LiquoriceLog.class);
        Actor upco5 = getOneObjectAtOffset( 0, -co, LightLeaves.class);
        Actor upco6 = getOneObjectAtOffset( 0, -co, CopperOre.class);
        //Left Collision
        Actor leftco = getOneObjectAtOffset( -co, -co/2, Grass.class);
        Actor leftco2 = getOneObjectAtOffset( -co, co/2, Grass.class);
        Actor leftco3 = getOneObjectAtOffset( -co, 0, Grass.class);
        Actor leftco4 = getOneObjectAtOffset( -co, -co/2, Dirt.class);
        Actor leftco5 = getOneObjectAtOffset( -co, co/2, Dirt.class);
        Actor leftco6 = getOneObjectAtOffset( -co, 0, Dirt.class);
        Actor leftco7 = getOneObjectAtOffset( -co, -co/2, LiquoriceLog.class);
        Actor leftco8 = getOneObjectAtOffset( -co, co/2, LiquoriceLog.class);
        Actor leftco9 = getOneObjectAtOffset( -co, 0, LiquoriceLog.class);
        Actor leftco10 = getOneObjectAtOffset( -co, -co/2, LightLeaves.class);
        Actor leftco11 = getOneObjectAtOffset( -co, co/2, LightLeaves.class);
        Actor leftco12 = getOneObjectAtOffset( -co, 0, LightLeaves.class);
        Actor leftco13 = getOneObjectAtOffset( -co, -co/2, Stone.class);
        Actor leftco14 = getOneObjectAtOffset( -co, co/2, Stone.class);
        Actor leftco15 = getOneObjectAtOffset( -co, 0, Stone.class);
        Actor leftco16 = getOneObjectAtOffset( -co, -co/2, CopperOre.class);
        Actor leftco17 = getOneObjectAtOffset( -co, co/2, CopperOre.class);
        Actor leftco18 = getOneObjectAtOffset( -co, 0, CopperOre.class);
        //Right Collision
        Actor rightco = getOneObjectAtOffset( co, -co/2, Grass.class);
        Actor rightco2 = getOneObjectAtOffset( co, co/2, Grass.class);
        Actor rightco3 = getOneObjectAtOffset( co, 0, Grass.class);
        Actor rightco4 = getOneObjectAtOffset( co, -co/2, Dirt.class);
        Actor rightco5 = getOneObjectAtOffset( co, co/2, Dirt.class);
        Actor rightco6 = getOneObjectAtOffset( co, 0, Dirt.class);
        Actor rightco7 = getOneObjectAtOffset( co, -co/2, LiquoriceLog.class);
        Actor rightco8 = getOneObjectAtOffset( co, co/2, LiquoriceLog.class);
        Actor rightco9 = getOneObjectAtOffset( co, 0, LiquoriceLog.class);
        Actor rightco10 = getOneObjectAtOffset( co, -co/2, LightLeaves.class);
        Actor rightco11 = getOneObjectAtOffset( co, co/2, LightLeaves.class);
        Actor rightco12 = getOneObjectAtOffset( co, 0, LightLeaves.class);
        Actor rightco13 = getOneObjectAtOffset( co, -co/2, Stone.class);
        Actor rightco14 = getOneObjectAtOffset( co, co/2, Stone.class);
        Actor rightco15 = getOneObjectAtOffset( co, 0, Stone.class);
        Actor rightco16 = getOneObjectAtOffset( co, -co/2, CopperOre.class);
        Actor rightco17 = getOneObjectAtOffset( co, co/2, CopperOre.class);
        Actor rightco18 = getOneObjectAtOffset( co, 0, CopperOre.class);
        //Collsion Cause and Effect
        if (upco!=null||upco2!=null||upco3!=null||upco4!=null||upco5!=null||upco6!=null){
            fall=1;
            ymove=0;
        }
        if (fall==1){
            falltimer+=1;
            if (falltimer==5){
                falltimer=0;
                ymove+=1;
            }
            if (ymove>16){
                ymove=16;
            }
            fall=0;
        }
        if (downco!=null||downco2!=null||downco3!=null||downco4!=null||downco5!=null||downco6!=null||downco7!=null||downco8!=null||downco9!=null||downco10!=null||downco11!=null||downco12!=null||downco13!=null||downco14!=null||downco15!=null||downco16!=null||downco17!=null||downco18!=null||getY()>getWorld().getHeight()-26){
            ymove=0;
            jumplimit=0;
            jump=0;
            fallonce=0;
            falltimer=0;
        }else{
            fall=1;
            fallonce=1;
        }
        if (leftco!=null||leftco2!=null||leftco3!=null||leftco4!=null||leftco5!=null||leftco6!=null||leftco7!=null||leftco8!=null||leftco9!=null||leftco10!=null||leftco11!=null||leftco12!=null||leftco13!=null||leftco14!=null||leftco15!=null||leftco16!=null||leftco17!=null||leftco18!=null){
            if (xmove<0){
                xmove=0;
            }
        }
        if (rightco!=null||rightco2!=null||rightco3!=null||rightco4!=null||rightco5!=null||rightco6!=null||rightco7!=null||rightco8!=null||rightco9!=null||rightco10!=null||rightco11!=null||rightco12!=null||rightco13!=null||rightco14!=null||rightco15!=null||rightco16!=null||rightco17!=null||rightco18!=null){
            if (xmove>0){
                xmove=0;
            }
        }
        if (upco!=null||upco2!=null||upco3!=null||upco4!=null||upco5!=null||upco6!=null){
            jump=0;
        }
        setLocation(getX()+xmove, getY()+ymove);
    }
}
