/*
 *          if (! default.isEmpty()){
                Actor Default = (Actor) default.get(0);
                if (Default!=null)getWorld().removeObject(Default);
            }
 * 
 */

import greenfoot.*;
import java.util.List;

public class Explosion extends Bomb
{
    int explosionTime=3;
    int scale=getImage().getWidth()/4;
    
    public void addedToWorld(World world)
    {
        getImage().scale(scale,scale);
        blockDestruction();
    }
    
    public void act() 
    {
        //Enlarge image over time
        getImage().scale(scale,scale);
        scale+=40;
        blockDestruction();
        //Remove if explosion time has run out
        if (explosionTime==0){
                getWorld().removeObject(this);
            }else{
                explosionTime--;
            }
    }
    
    public void blockDestruction()
    {
        for (int i=0; i<10; i++){
            List grass = getObjectsInRange(scale/2,Grass.class);
            List dirt = getObjectsInRange(scale/2,Dirt.class);
            List stone = getObjectsInRange(scale/2,Stone.class);
            List ladder = getObjectsInRange(scale/2,Ladder.class);
            List lightleaves = getObjectsInRange(scale/2,LightLeaves.class);
            List liquoricelog = getObjectsInRange(scale/2,LiquoriceLog.class);
            List copper = getObjectsInRange(scale/2,CopperOre.class);
            if (! grass.isEmpty()){
                Actor Grass = (Actor) grass.get(0);
                if(Grass!=null)getWorld().removeObject(Grass);
            }
            if (! dirt.isEmpty()){
                Actor Dirt = (Actor) dirt.get(0);
                if(Dirt!=null)getWorld().removeObject(Dirt);
            }
            if (! stone.isEmpty()){
                Actor Stone = (Actor) stone.get(0);
                if(Stone!=null)getWorld().removeObject(Stone);
            }
            if (! ladder.isEmpty()){
                Actor Ladder = (Actor) ladder.get(0);
                if(Ladder!=null)getWorld().removeObject(Ladder);
            }
            if (! lightleaves.isEmpty()){
                Actor LightLeaves = (Actor) lightleaves.get(0);
                if(LightLeaves!=null)getWorld().removeObject(LightLeaves);
            }
            if (! liquoricelog.isEmpty()){
                Actor LiquoriceLog = (Actor) liquoricelog.get(0);
                if(LiquoriceLog!=null)getWorld().removeObject(LiquoriceLog);
            }
            if (! copper.isEmpty()){
                Actor Copper = (Actor) copper.get(0);
                if (Copper!=null)getWorld().removeObject(Copper);
            }
        }
    }
}
