import greenfoot.*;
import java.awt.Color;

public class GameWorld extends World
{
    int AS = 96;
    int x = 0;  
    int y = Greenfoot.getRandomNumber(20)*16+AS;
    int phase = 0;
    int CopperP;
    int DiamondP;
    boolean caveGenerate = false;
    int caveTop = Greenfoot.getRandomNumber(10)+Greenfoot.getRandomNumber(5)+4;
    int caveBottom = Greenfoot.getRandomNumber(10)+caveTop+5;
    int playerspawntimer=0;
    int playerspawn=0;
    
    int time=0;
    public GameWorld()  
    {  
        super(1120, 640, 1);
        GreenfootImage bg = getBackground();
        Color LIGHT_BLUE = new Color(153, 204, 255);
        bg.setColor(LIGHT_BLUE);
        bg.fill();
        addObject(new MouseControl(), 0, 0);
        addObject(new Sun(),0, 320);
        addObject(new LadderButton(), 18, 19);
        addObject(new BombButton(), 54, 19);
        addObject(new Health(), 38, 50);
    }
  
    public void act()  
    {  
        setPaintOrder(LadderButton.class,BombButton.class,Orb.class,Orb2.class,Bomb.class,DiamondOre.class,Stone.class,Grass.class,Dirt.class,CopperOre.class,LightLeaves.class,Player.class,LiquoriceLog.class,Ladder.class,Dark.class,Sun.class,Moon.class);
        backgroundGenerate();
        generate();
        if (playerspawntimer!=100){
            playerspawntimer+=1;
        }else{
            if (playerspawn==0){
                addObject(new Player(),560, 0);
                playerspawn+=1;
            }
        }
    }
    //Everything Below this comment isn't mine!
    public void generate()  
    {  
        if(x<=getWidth()){  
            int randomWidth = Greenfoot.getRandomNumber(5)+4;
            for(int i=0;i<getHeight();i+=16)  
            {
                if(caveGenerate == false&&Greenfoot.getRandomNumber(300)==0){
                    caveTop = Greenfoot.getRandomNumber(10)+Greenfoot.getRandomNumber(5)+4;
                    caveBottom = Greenfoot.getRandomNumber(10)+caveTop+5;
                    caveGenerate = true;
                }
                if(phase==0)
                {
                    if(Greenfoot.getRandomNumber(50)==0)
                    {
                        addObject(new TreeGen(), x, i+y);
                    }else{
                        addObject(new Grass(), x, i+y);
                    }
                }else if(phase < randomWidth){
                    addObject(new Dirt(), x, i+y);
                }else if(caveGenerate == true && phase>caveTop && phase<caveBottom){
                    if(Greenfoot.getRandomNumber(90)==0)
                    {
                        caveGenerate = false;
                    }
                }else if(Greenfoot.getRandomNumber(200)==0 || (Greenfoot.getRandomNumber(20)==0 && (CopperP==phase||CopperP==phase-1||CopperP==phase+2))){
                    addObject(new CopperOre(), x, i+y);
                    CopperP = phase;
                }else if(phase > 30 && Greenfoot.getRandomNumber(100)==0 || (Greenfoot.getRandomNumber(80)==0 && (DiamondP==phase||DiamondP==phase-1||DiamondP==phase+2))){
                    addObject(new DiamondOre(), x, i+y);
                    DiamondP = phase;
                }else{
                    addObject(new Stone(), x, i+y);
                }
                phase++;
            }  
            x+=16;
            phase = 0;
            int upDown = Greenfoot.getRandomNumber(4);
            if(upDown == 0 && y > AS){
                y -= Greenfoot.getRandomNumber(2)*16;
            }else if(upDown == 1 && y < getHeight()){
                y += Greenfoot.getRandomNumber(2)*16;
            }else if(upDown == 2 && y > AS){
                y -= Greenfoot.getRandomNumber(3)*16;
            }else if(upDown == 3 && y < getHeight()){
                y += Greenfoot.getRandomNumber(3)*16;
            }
            
        }
    }
    public void backgroundGenerate()  
    {  
        if(x<=getWidth()){  
            int randomWidth = Greenfoot.getRandomNumber(5)+4;
            for(int i=0;i<getHeight();i+=16)  
            {
                if(phase==0)
                {
                    addObject(new DarkGrass(), x, i+y);
                }else if(phase < randomWidth){
                    addObject(new DarkDirt(), x, i+y);
                }else if(Greenfoot.getRandomNumber(200)==0 || (Greenfoot.getRandomNumber(20)==0 && (CopperP==phase||CopperP==phase-1||CopperP==phase+2))){
                    addObject(new DarkCopperOre(), x, i+y);
                    CopperP = phase;
                }else if(Greenfoot.getRandomNumber(800)==0 || (Greenfoot.getRandomNumber(80)==0 && (DiamondP==phase||DiamondP==phase-1||DiamondP==phase+2))){
                    addObject(new DarkDiamondOre(), x, i+y);
                    DiamondP = phase;
                }else{
                    addObject(new DarkStone(), x, i+y);
                }
                phase++;
            }
            phase = 0;
            int upDown = Greenfoot.getRandomNumber(4);
            if(upDown == 0 && y > AS){
                y -= Greenfoot.getRandomNumber(2)*16;
            }else if(upDown == 1 && y < getHeight()){
                y += Greenfoot.getRandomNumber(2)*16;
            }else if(upDown == 2 && y > AS){
                y -= Greenfoot.getRandomNumber(3)*16;
            }else if(upDown == 3 && y < getHeight()){
                y += Greenfoot.getRandomNumber(3)*16;
            }
            int wideThin = Greenfoot.getRandomNumber(4);
            if(wideThin == 0 && caveBottom>5){
                caveTop -= Greenfoot.getRandomNumber(2);
                caveBottom -= Greenfoot.getRandomNumber(2);
            }else if(wideThin == 1){
                caveTop += Greenfoot.getRandomNumber(2);
                caveBottom += Greenfoot.getRandomNumber(2);
            }else if(wideThin == 2 && caveBottom>5){
                caveTop -= Greenfoot.getRandomNumber(3);
                caveBottom -= Greenfoot.getRandomNumber(3);
            }else if(wideThin == 3){
                caveTop += Greenfoot.getRandomNumber(4);
                caveBottom += Greenfoot.getRandomNumber(4);
            }
        }
    }
}
